# SPDX-License-Identifier: CC0-1.0

{ nixpkgs, dhallApps, packages }:

rec {

  linux-image =
    let drv = import ./linux-image { inherit nixpkgs dhallApps packages; };
    in {
      type = "app";
      program = "${drv}/bin/linux-image";
    };

  nova-image = let
    drv = import ./nova-image {
      stdenv = packages.stdenv;
      inherit nixpkgs dhallApps packages;
    };
  in {
    type = "app";
    program = "${drv}/bin/nova-image";
    function = attrs: bootDesc:
      nixpkgs.runCommand "nova-iso" (attrs // { inherit bootDesc; })
      "${drv}/bin/nova-image $out $bootDesc";
  };

  nova-iso = let
    drv = import ./nova-iso {
      stdenv = packages.stdenv;
      inherit nixpkgs packages nova-image;
    };
  in {
    type = "app";
    program = "${drv}/bin/nova-iso";
    function = attrs: bootDesc:
      nixpkgs.runCommand "nova.iso" attrs
      ''${drv}/bin/nova-iso $out "${bootDesc}"'';
  };

  render-init =
    let drv = import ./render-init { inherit nixpkgs dhallApps packages; };
    in {
      type = "app";
      program = "${drv}/bin/render-init";
    };

}
